/*
 * ----------------------------------------------
 *
 * This software belongs to the zzzutils package.
 *
 * Copyright (c) 2003 Fabian "zzznowman" Pietsch.
 * All rights reserved.
 *
 * ----------------------------------------------
 */

/*
 * misc.c -- helper functions for zzzutils
 *
 *****************************************
 *
 *
 */

#include <stdio.h>
#include <stdarg.h>


#if 0
void zperror_verbose(const char *file, const int line, const char *str)
{
	char tmp[255];

	if (str)
		snprintf(tmp, sizeof(tmp), "%s(%i): error: %s", file, line, str);
	else
		snprintf(tmp, sizeof(tmp), "%s(%i): error", file, line);
	perror(tmp);
}
#endif

void zperror_verbose(const char *file, const int line, const char *fmt, ...)
{
	va_list ap;
	char tmp[255];
	char fmt2[255];

	if (fmt)
	{
		snprintf(fmt2, sizeof(fmt2), "%s(%i): error: %s", file, line, fmt);

		va_start(ap, fmt);
		vsnprintf(tmp, sizeof(tmp), fmt2, ap);
		va_end(ap);
	}
	else
		snprintf(tmp, sizeof(tmp), "%s(%i): error", file, line);

	perror(tmp);
}

int zerror_verbose(const char *file, const int line, const char *fmt, ...)
{
	va_list ap;
	char fmt2[255];
	int i_chars;

	snprintf(fmt2, sizeof(fmt2), "%s(%i): error: %s\n", file, line, fmt);

	va_start(ap, fmt);
	i_chars = vfprintf(stderr, fmt2, ap);
	va_end(ap);

	return i_chars;
}

int zwarn_verbose(const char *file, const int line, const char *fmt, ...)
{
	va_list ap;
	char fmt2[255];
	int i_chars;

	snprintf(fmt2, sizeof(fmt2), "%s(%i): warning: %s\n", file, line, fmt);

	va_start(ap, fmt);
	i_chars = vfprintf(stderr, fmt2, ap);
	va_end(ap);

	return i_chars;
}
