/*
 * ----------------------------------------------------------------------------
 *
 * ztlist.h -- list of telephone numbers for zzztel
 * Copyright (C) 2004  Fabian Pietsch
 *
 * ----------------------------------------------------------------------------
 *
 */

/*
 * zzztel telephone number list
 ******************************************************************************
 * list of telephone numbers for zzztel
 *
 */

/* handle multiple inclusions */
#ifndef __ZTLIST_H
#define __ZTLIST_H

/* need ZTTN in data types */
#include "zttn.h"


/*
 * data types
 */

/* telephone number list element */
typedef struct ZTListEl ZTListEl;
struct ZTListEl
{
	ZTTN     *tn;    /* telephone number stored in this list element */
	ZTListEl *next;  /* next element in linked list                  */
};

/* telephone number list */
typedef struct
{
	int        count;  /* count of telephone numbers in list        */
	ZTListEl  *first;  /* first element in linked list              */
	ZTListEl **end;    /* linked list's end (hook for new elements) */
} ZTList;


/*
 * function prototypes
 */

/* ZTListEl */
extern ZTListEl *ztlistel_new(ZTTN *tn);
extern void      ztlistel_free(ZTListEl *element);

/* ZTList */
extern ZTList   *ztlist_new(void);
extern ZTListEl *ztlist_add(ZTList *list, ZTTN *tn);
extern int       ztlist_del(ZTList *list, ZTListEl *element);
extern ZTListEl *ztlist_idx_to_ptr(ZTList *list, int index);
extern int       ztlist_ptr_to_idx(ZTList *list, ZTListEl *element);
extern void      ztlist_free(ZTList *list);

#endif /* __ZTLIST_H */
