/*
 * ----------------------------------------------------------------------------
 * 
 * ztui.h -- zzztel user interface
 * Copyright (C) 2003, 2004  Fabian Pietsch
 *
 * ----------------------------------------------------------------------------
 *
 */

/* handle multiple inclusions */
#ifndef __ZTUI_H
#define __ZTUI_H

/* data structures needed for ZTUITNList */
#include "ztdb.h"
#include <curses.h>
#include <panel.h>

/* telephone number list view structure */
typedef struct
{
	PANEL  *full_pan;        /* panel for full window     */
	WINDOW *full_win;        /* full window               */
	int     full_maxy;       /* full window's height      */
	int     full_maxx;       /* full window's width       */

	WINDOW *inner_win;       /* inner window              */
	int     inner_maxy;      /* inner window's height     */
	int     inner_maxx;      /* inner window's width      */

	ZTList *list;            /* telephone number list     */
	int     offset;          /* scrolling offset          */
	int     pos;             /* active tn object in list  */

	int     prev_offset;     /* previous offset           */
	int     prev_pos;        /* previous position         */
}
ZTUIView;

/* telephone list view offset extremals */
#define ZTUI_VOFFSET_MIN(view) (0)
#define ZTUI_VOFFSET_MAX(view) (MAX((view).list->count - (view).inner_maxy, 0))

#if 0
/* form element */
enum ztform_element_type {
	ZTFET_LABEL,
	ZTFET_INPUT
};
struct ztform_element {
	enum ztform_element_type type;	/* type of element		*/
	int y, x;			/* position			*/
	int h, w;			/* size (height, width)		*/
	char *data;			/* LABEL: caption; INPUT: input	*/
};
#endif

/* prototypes */
#if 0
extern int ztui_form(int y, int x, int h, int w, struct ztform_element **elv, int elc);
extern int ztui_tns_show(const ZTSearch *search);
#endif
extern int ztui_refresh(void);
extern int ztui_tns_insert(int x, int y, int width, int height, ZTTN **tncopy);
extern int ztui_tns_search(void);
extern int ztui_tns_view(ZTList *list);
extern int ztui_main(void);

#endif /* __ZTUI_H */
