/*
 * ----------------------------------------------------------------------------
 *
 * zzztel.c
 * Copyright (C) 2003 Fabian "zzznowman" Pietsch
 *
 * ----------------------------------------------------------------------------
 *
 */

/*
 * main module
 ******************************************************************************
 * initial invocation handling
 *
 */

#include "zzztel.h"
#include "zzzutils.h"
#include "ztdb.h"
#include "ztui.h"

#include <stdio.h>
#include <stdlib.h>

#if 0
static int insnumber(void);
static int delnumber(void);
static int searchdb(void);
static void tnout(const struct zttelnum *tn);

/* insert telephone number into database */
static int insnumber()
{
	ZTTN tn;

	/* prepare tn */
	tn.pre_int = "49";
	tn.pre_local = "1234";
	tn.line = "56789";
	tn.comment = "First M. Last";

	/* insert tn into database */
	printf("Inserting into database:\n");
	tnout(&tn);
	if (ztdb_tnins(&tn) < 1)
	{
		zerror("can't insert telephone number");
		return -1;
	}

	/* success */
	return 0;
}

/* delete telephone number from database */
static int delnumber()
{
	ZTTN     tn = { NULL, NULL, NULL, NULL };
	ZTSearch search;

	/* prepare search */
	tn.line = "56789";
	search.tn = &tn;
	search.fields = ZTS_LINE;
	search.limit = 1;

	/* delete from database */
	printf("Deleting from database:\n");
	tnout(&tn);
	if (ztdb_tndelall(&search) < 1)
	{
		zerror("can't delete telephone number");
		return -1;
	}

	/* success */
	return 0;
}

/* search database for telephone numbers */
static int searchdb()
{
	int   rows;
	ZTTN *tn;

	/* actually do the search */
	if ((rows = ztdb_tnquery(NULL)) < 0)
	{
		zerror("ztdb_tnquery() failed");
		return -1;
	}
	printf("Found %d results:\n", rows);

	/* get the results */
	while ((tn = ztdb_tnget()))
	{
		tnout(tn);
		free(tn);
	}

	/* success */
	return 0;
}

/* output formatted telephone number */
static void tnout(const ZTTN *tn)
{
	if (tn)
		printf("Telnum: +%s %s %s\t(%s)\n", tn->pre_int, tn->pre_local,
		       tn->line, tn->comment);
	else
		printf("Telnum: (NULL)\n");
}
#endif

/* program execution entry point */
int main(const int argc, const char *argv[])
{
	/* initialize database environment */
	if (ztdb_init())
	{
		zerror("database environment initialization failed");
		exit(EXIT_FAILURE);
	}

	/* invoke user interface */
	if (ztui_main())
	{
		zerror("user interface failed");
		exit(EXIT_FAILURE);
	}

	/* deinitialize database environment */
	if (ztdb_finish())
	{
		zerror("database environment deinitialization failed");
		exit(EXIT_FAILURE);
	}

	/* indicate success */
	exit(EXIT_SUCCESS);
}
